Subject: Re: [PATCH 0/2] Tentative fix for the divide-by-zero on score/paris/..

From: Guenter Roeck <[email-masked]>
Date: Wed, 15 Apr 2015 08:31:50 -0700

On Wed, Apr 15, 2015 at 03:46:37PM +0200, Quentin Casasnovas wrote:
> On Wed, Apr 15, 2015 at 06:26:58AM -0700, Guenter Roeck wrote:
> > On 04/15/2015 01:54 AM, Quentin Casasnovas wrote:
> > >
> > > Let me know if this makes things better..
> > >
> 
> Hi Guenter,
> 
> > 
> > the crash is fixed, but now I get
> >
> 
> That's a first step.. :)
> 
> > FATAL: The relocation at __ex_table+0x4 references
> > [...]
> > 
> > for parisc:defconfig,
> > for score:allnoconfig, and
> > for mn10300:defconfig.
> 
> Thanks for the testing, much appreciated!
> 
> > 
> > While I agree that those should get fixed (if they are real problems,
> > especially the ones for parisc and mn10300), I don't think it is
> > a good idea to fail the build because of it.
> 
> That's a tough one..  I think it's pretty bad in general to have some
> crufts in the ex_table referencing non-executable sections.  Note that it
> will not make the build fail if the relocation _seems_ legit (jump to an
> executable section even though it's not part of the white-list) but in
> those cases, something really does look wrong and could potentially have a
> security impact so I thought the build failure was a good thing to do.
> 
Hi Quentin,

Guess we have a different philosophy; mine is "do no harm".

> Now, if it's a problem in modpost (which is likely!), then obviously I'd be
> happy to try and help fix that!
> 
> > 
> > Note that I did find the problem in the score build; that was a real bug.
> > I don't know what may be wrong with the others.
> 
> Cool!  Mind CC'ing me to your fix, I'm curious :)
> 
I'll do that.

> Regarding the others, if you've compiled them with debug information, you
> should be able to do some addr2line magic incantation to find the offending
> code.  I've also added scripts/check_extable.sh which you might be able to
> use to get more details about the failures (or simply use the same logic in
> there to know where those maybe-wrong-relocations are coming from).
> 
> I'm surprised/concerned that some sections appear to have no name though
> (indicating yet another bug in my modpost changes?).. If you can share the
> object files then I can have a look (and possibly help with the addr2line
> incantation).
> 
I don't really have time to do that; please keep in mind that I am not getting
paid for this and do it in my free time. Both the parisc and mn10300 (am33)
tool chains are available from kernel.org; it should be straightforward to 
install them and see yourself what is going on. Unlike score I did not find
the problem in those architectures with code inspection.

Thanks,
Guenter